<template>
  <md-dialog duplicator :md-active.sync="active" @md-closed="close">
    <md-dialog-content>
      <md-steppers :md-active-step.sync="stage" md-linear>
        <md-step id="modeName" md-label="Mode Selection" md-description="Select or specify the target mode" :md-editable="false">
          <md-field md-clearable>
            <label>Destination Mode</label>
            <md-input v-model="newMode" placeholder="new mode name"></md-input>
          </md-field>
          <h3>Or copy to an existing mode:</h3>
          <p>Showing {{search(newMode, keys).length}}/{{keys.length}}</p>
          <md-list keylist class="md-dense">
            <md-list-item v-for="key in search(newMode, keys)" :key="key.ID" :deprecated="key.VALID !== 'Y'" @click="select(key.ID)">{{key.ID}}</md-list-item>
          </md-list>
          <div buttons>
            <md-button @click="stage = modeIsNew ? 'description' : 'confirm'">next</md-button>
          </div>
        </md-step>
        <md-step id="description" md-label="Description" :md-editable="false">
          <md-field>
            <label>New Key Description</label>
            <md-textarea v-model="description" required></md-textarea>
          </md-field>
          <div buttons>
            <md-button @click="stage = 'modeName'">previous</md-button>
            <md-button @click="duplicate" class="md-raised md-primary">confirm</md-button>
          </div>
        </md-step>
      </md-steppers>
    </md-dialog-content>
  </md-dialog>
</template>

<script lang="ts">
import { Component, Vue, Prop, Watch } from 'vue-property-decorator';
import { MdSwitch, MdCard, MdSteppers } from 'vue-material/dist/components';
import { store } from '../../store';
import { KeyPathKey } from '../../store/editor';
import goStyle from '../../lib/to';
import axios from '../../lib/axios';

Vue.use(MdSteppers);
@Component({
  components: {
  },
})
export default class extends Vue {

  // ignore the 'Avoid mutating a prop directly' warning
  // the md-dialog doesn't close properly without .sync
  // and the syncing is fixed with @md-closed
  @Prop()
  private active = false;

  @Prop()
  private modetable = '';

  @Prop()
  private keyentry!: KeyPathKey;

  @Prop()
  private currentmode!: string;

  private newMode = '';
  private modeIsNew = false;
  private description = '';

  private stage: 'modeName' | 'description' = 'modeName';

  private keys = [];

  public mounted() {
    this.modetableChanged();
  }

  @Watch('modetable')
  @Watch('keyentry.key')
  private async modetableChanged() {
    if (!this.modetable || !this.keyentry) {
      return;
    }
    const [response, err] = await goStyle(axios({
      url: '/api/v0/db/tables/' + encodeURIComponent(this.modetable) + '/' +
        encodeURIComponent(this.keyentry.key) + '/getkeys',
      method: 'POST',
    }));
    if (!err) {
      this.keys = response.data.rows.sort(k => k.VALID !== 'Y' ? 1 : -1);
    }
  }

  private search(newMode, keys) {
    if (!newMode || !keys || keys.length === 0) {
      return keys || [];
    }
    const r = keys.filter(o => o.ID.toLowerCase().indexOf(newMode.toLowerCase()) !== -1);
    this.modeIsNew = r.length === 0;
    return r;
  }

  private select(key) {
    this.newMode = key;
    this.description = `Duplicated ${this.keyentry.key} (${this.currentmode} mode) to ${this.newMode}`;
    this.stage = 'description';
  }

  private duplicate() {
    this.$emit('duplicate', {mode: this.newMode, description: this.description});
    this.newMode = '';
    this.stage = 'modeName';
  }

  private close() {
    this.$emit('close');
    console.log('closing');

  }
}
</script>

<style lang="scss">
[duplicator] {
  [buttons] {
    display: flex;
    flex-direction: row;
    justify-content: space-between;
  }

  [keylist] {
    height: 500px;
    overflow: auto;

    .md-list-item {
      &[deprecated] {
        div {
          color: gray;
        }
      }
    }
  }
}
</style>
